#TEMPLATE (bdExdivio,'Recall Version Resource Info')
#EXTENSION(bdVersionInfo,'Recall Version Resource Info Extension Template'),PROCEDURE
#INSERT(%OOPPrompts(ABC))
#PREPARE
  #CALL(%ReadABCFiles(ABC))
  #CALL(%SetClassItem(ABC),'VerInfo' & %ActiveTemplateInstance)
  #CALL(%SetOOPDefaults(ABC),'VerInfo' & %ActiveTemplateInstance,'bdVersionInfo')
#ENDPREPARE
#!
#SHEET
  #TAB('General')
    #DISPLAY
    #DISPLAY('The Recall Version Resource Info Extension Template')
    #DISPLAY('instantiates an object that is capable of retrieving')
    #DISPLAY('version strings from the version resource information')
    #DISPLAY('linked into a file.')
    #DISPLAY
    #DISPLAY('The object allows your program to access this version')
    #DISPLAY('resource information for things such as file version,')
    #DISPLAY('company name, product version, etc., along with any')
    #DISPLAY('other custom items that may have been added')
    #DISPLAY
    #DISPLAY('ex. To get file version: Call ObjName.GetFileVersion()')
    #DISPLAY
    #PROMPT('Add File Version to Window Title',CHECK),%AddToTitleBar,DEFAULT('1'),AT(5)
    #PROMPT('Automatically Link API Calls into project',CHECK),%AutoLink,DEFAULT('1'),AT(5) 
    #DISPLAY
    #DISPLAY('For more information, visit www.clarionmag.com')
  #ENDTAB
  #TAB('Classes')
    #WITH(%ClassItem, 'VerInfo' & %ActiveTemplateInstance)
      #INSERT(%ClassPrompts(ABC))
    #ENDWITH
  #ENDTAB
#ENDSHEET
#!
#ATSTART
  #CALL(%ReadABCFiles(ABC))
  #CALL(%SetClassItem(ABC),'VerInfo' & %ActiveTemplateInstance)
  #CALL(%SetOOPDefaults(ABC),'VerInfo' & %ActiveTemplateInstance,'bdVersionInfo')
  #FIX(%ClassItem,'VerInfo' & %ActiveTemplateInstance)
#ENDAT
#!
#AT (%CustomGlobalDeclarations)
#IF (%AutoLink)
#PROJECT('bdVersion.LIB')
#ENDIF
#ENDAT
#!
#AT(%WindowEventHandling,'OpenWindow'),PRIORITY(4400),DESCRIPTION('Add File Version to Title Bar')
#IF (%AddToTitleBar)
0{PROP:Text} = CLIP(0{PROP:Text}) & ' ' & %ThisObjectName.GetFileVersion()  !From VerInfo Template
#ENDIF
#ENDAT
#!
#AT(%GatherObjects)
  #CALL(%ReadABCFiles(ABC))
  #CALL(%SetClassItem(ABC),'VerInfo' & %ActiveTemplateInstance)
  #ADD(%ObjectList, %ThisObjectName)
  #SET(%ObjectListType,'bdVersionInfo')
#ENDAT
#!This INCLUDES the appropriate .INC file and instantiates the object
#!along with any new or derived methods the programmer has added.
#AT(%LocalDataClasses)
#CALL(%SetClassItem(ABC), 'VerInfo' & %ActiveTemplateInstance)
#INSERT(%GenerateClassDefinition(ABC), %ClassLines)
#ENDAT
#!
#!
#!This section sets up the embed points in the embed tree based on the methods available
#!in the class and is generic to the template chain.
#AT(%LocalProcedures)
  #CALL (%GenerateVirtuals(ABC), 'VerInfo' & %ActiveTemplateInstance,'Local Objects|Abc Objects|Exdivio Recall Version Resource Info Object (' & %ThisObjectName & ')','%bdVerInfoVirtuals(bdExdivio)') 
#ENDAT
#! Generate an automatic call to the parent method when programmer chooses to derive an existing method
#AT(%bdVerInfoClassMethodCodeSection,%ActiveTemplateInstance),PRIORITY(5000),DESCRIPTION('Parent Call'),WHERE(%ParentCallValid())
  #CALL(%GenerateParentCall(ABC))
#ENDAT
#!----------------------------------------------------------------------------------------------------------
#!GROUP declarations:
#!-----------------------------------------------------------------------------------------------------------
#!Used for providing embed points around the methods that are defined in a class.
#GROUP(%bdVerInfoVirtuals, %TreeText, %DataText, %CodeText)
#EMBED(%bdVerInfoClassMethodDataSection,'bdVerInfo - Method Data Section'),%ActiveTemplateInstance,%pClassName,%pClassMethod,%pClassMethodPrototype,LABEL,DATA,PREPARE(,%FixClassName(%FixBaseClassToUse('VerInfo'))),TREE(%TreeText & %DataText)
#?%NULL
  #?CODE
  #EMBED(%bdVerInfoClassMethodCodeSection,'bdVerInfo - Method Executable Code Section'),%ActiveTemplateInstance,%pClassName,%pClassMethod,%pClassMethodPrototype,PREPARE(,%FixClassName(%FixBaseClassToUse('VerInfo'))),TREE(%TreeText & %CodeText)
#!-----------------------------------------------------------------------------------------------------------
#!Used along with the above group to add a parent call for methods the programmer has derived.
#GROUP(%ParentCallValid),AUTO
   #IF (~VAREXISTS(%RtVal))
       #DECLARE(%RtVal)
   #ENDIF
   #INSERT (%ParentCallValid(ABC)),%RtVal
   #RETURN %RtVal
#!
#!-----------------------------------------------------------------------------------------------------------
